#ifdef STATISTICS
/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/include/Statistics.h"

#include <sstream>
using namespace std;

namespace morpheo {
namespace behavioural {
namespace stage_1_ifetch {
namespace predictor {
namespace meta_predictor {


  string Statistics::print (uint32_t depth,
			    string   component_stat)
  {
    log_printf(FUNC,Meta_Predictor,"print","Begin");

    string        tab = string(depth,'\t');
    ostringstream msg;

    msg << tab << "<meta_predictor name=\"" << _name << "\" >" << endl
        << print_body(depth+1) << endl
	<< component_stat
	<< tab << "</meta_predictor>" << endl;
    
    log_printf(FUNC,Meta_Predictor,"print","End");

    return msg.str();
  };

  string Statistics::print (uint32_t depth)
  {
    return print(depth,"");
  };

  ostream& operator<< (ostream& output_stream ,
		       morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::Statistics & x)
  {
    output_stream << x.print(0);

    return output_stream;
  };

}; // end namespace meta_predictor
}; // end namespace predictor
}; // end namespace stage_1_ifetch

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
